unit uBaralhoEditor;

interface

uses
  {$IFDEF VER130}  // Se Delphi 5
    DesignIntf,
  {$ELSE} // Seno
    Designintf, DesignEditors,
  {$ENDIF}
  Classes;

type

  TBaralhoEditor = class(TEnumProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
    procedure SetValue(const Value: string); override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

implementation

uses
  uCartaBasico;

function TBaralhoEditor.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList];
end;

procedure TBaralhoEditor.GetValues(Proc: TGetStrProc);
begin
  Proc('s');
  Proc('Dois');
  Proc('Trs');
  Proc('Quatro');
  Proc('Cinco');
  Proc('Seis');
  Proc('Sete');
  Proc('Oito');
  Proc('Nove');
  Proc('Dez');
  Proc('Valete');
  Proc('Dama');
  Proc('Rei');
  Proc('Curinga');
end;

function TBaralhoEditor.GetValue: string;
begin
  case GetOrdValue of
    LongInt(baAs): Result := 's';
    LongInt(baDois): Result := 'Dois';
    LongInt(baTres): Result := 'Trs';
    LongInt(baQuatro): Result := 'Quatro';
    LongInt(baCinco): Result := 'Cinco';
    LongInt(baSeis): Result := 'Seis';
    LongInt(baSete): Result := 'Sete';
    LongInt(baOito): Result := 'Oito';
    LongInt(baNove): Result := 'Nove';
    LongInt(baDez): Result := 'Dez';
    LongInt(baValete): Result := 'Valete';
    LongInt(baDama): Result := 'Dama';
    LongInt(baRei): Result := 'Rei';
    LongInt(baCuringa): Result := 'Curinga';
  end;
end;

procedure TBaralhoEditor.SetValue(const Value: string);
begin
    if (Value = 's') then SetOrdValue(LongInt(baAs));
    if (Value = 'Dois') then SetOrdValue(LongInt(baDois)) ;
    if (Value = 'Trs') then SetOrdValue(LongInt(baTres)) ;
    if (Value = 'Quatro') then SetOrdValue(LongInt(baQuatro)) ;
    if (Value = 'Cinco') then SetOrdValue(LongInt(baCinco)) ;
    if (Value = 'Seis') then SetOrdValue(LongInt(baSeis)) ;
    if (Value = 'Sete') then SetOrdValue(LongInt(baSete)) ;
    if (Value = 'Oito') then SetOrdValue(LongInt(baOito)) ;
    if (Value = 'Nove') then SetOrdValue(LongInt(baNove)) ;
    if (Value = 'Dez') then SetOrdValue(LongInt(baDez)) ;
    if (Value = 'Valete') then SetOrdValue(LongInt(baValete));
    if (Value = 'Dama') then SetOrdValue(LongInt(baDama));
    if (Value = 'Rei') then SetOrdValue(LongInt(baRei));
    if (Value = 'Curinga') then SetOrdValue(LongInt(baCuringa));
end;

end.
