unit uBaralhoUnoEditor;

interface

uses
  Classes,
  {$IFDEF VER130}  // Se Delphi 5
    DesignIntf,
  {$ELSE} // Seno
    Designintf, DesignEditors,
  {$ENDIF}
  uBaralhoEditor;

type

  TBaralhoUnoEditor = class(TBaralhoEditor)
  public
    function GetValue: string; override;
    procedure SetValue(const Value: string); override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

implementation

uses
  uCartaUno;

procedure TBaralhoUnoEditor.GetValues(Proc: TGetStrProc);
begin
  Proc('Zero');
  Proc('Um');
  Proc('Dois');
  Proc('Trs');
  Proc('Quatro');
  Proc('Cinco');
  Proc('Seis');
  Proc('Sete');
  Proc('Oito');
  Proc('Nove');
  Proc('Pular');
  Proc('Inverter');
  Proc('Comprar +2');
  Proc('Curinga');
  Proc('Curinga +4');
end;

function TBaralhoUnoEditor.GetValue: string;
begin
  case GetOrdValue of
    LongInt(buZero): Result := 'Zero';
    LongInt(buUm): Result := 'Um';
    LongInt(buDois): Result := 'Dois';
    LongInt(buTres): Result := 'Trs';
    LongInt(buQuatro): Result := 'Quatro';
    LongInt(buCinco): Result := 'Cinco';
    LongInt(buSeis): Result := 'Seis';
    LongInt(buSete): Result := 'Sete';
    LongInt(buOito): Result := 'Oito';
    LongInt(buNove): Result := 'Nove';
    LongInt(buPular): Result := 'Pular';
    LongInt(buInverter): Result := 'Inverter';
    LongInt(buComprar2): Result := 'Comprar +2';
    LongInt(buCuringa): Result := 'Curinga';
    LongInt(buCuringa4): Result := 'Curinga +4';
  end;
end;

procedure TBaralhoUnoEditor.SetValue(const Value: string);
begin
    if (Value = 'Zero') then SetOrdValue(LongInt(buZero));
    if (Value = 'Um') then SetOrdValue(LongInt(buUm));
    if (Value = 'Dois') then SetOrdValue(LongInt(buDois)) ;
    if (Value = 'Trs') then SetOrdValue(LongInt(buTres)) ;
    if (Value = 'Quatro') then SetOrdValue(LongInt(buQuatro)) ;
    if (Value = 'Cinco') then SetOrdValue(LongInt(buCinco)) ;
    if (Value = 'Seis') then SetOrdValue(LongInt(buSeis)) ;
    if (Value = 'Sete') then SetOrdValue(LongInt(buSete)) ;
    if (Value = 'Oito') then SetOrdValue(LongInt(buOito)) ;
    if (Value = 'Nove') then SetOrdValue(LongInt(buNove)) ;
    if (Value = 'Pular') then SetOrdValue(LongInt(buPular)) ;
    if (Value = 'Inverter') then SetOrdValue(LongInt(buInverter));
    if (Value = 'Comprar +2') then SetOrdValue(LongInt(buComprar2));
    if (Value = 'Curinga') then SetOrdValue(LongInt(buCuringa));
    if (Value = 'Curinga +4') then SetOrdValue(LongInt(buCuringa4)) ;
end;


end.
