unit uCarta;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  uCartaBasico;

type

  TCarta = class(TCartaBasico)
  private
    { Private declarations }
  protected
    function GetCarta: TBaralho;
    function GetNaipe: TNaipe;
    procedure SetCarta(pValor: TBaralho);
    procedure SetNaipe(pValor: TNaipe);
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property Carta: TBaralho read GetCarta write SetCarta;
    property Naipe: TNaipe read GetNaipe write SetNaipe;
  end;

implementation

var
  bmpCartasNormal: TBitmap;
  bmpCartaVirada: TBitmap;
  bmpCartaCuringa: TBitmap;

{ TCarta}

constructor TCarta.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FCartaAtual := Integer(baAs);
end;

destructor TCarta.Destroy;
begin
  inherited Destroy;
end;

function TCarta.GetCarta: TBaralho;
begin
  Result := TBaralho(FCartaAtual);
end;

function TCarta.GetNaipe: TNaipe;
begin
  Result := TNaipe(FSuite);
end;

procedure TCarta.Paint;
begin
  inherited Paint;

  if FExibir then
  begin
    case Carta of
      baCuringa:
        BitBlt(bmpCarta.Canvas.Handle, 0, 0, LARGURA_CARTA, ALTURA_CARTA,
          bmpCartaCuringa.Canvas.Handle, 0, 0, FModoPintura);
      else
        BitBlt(bmpCarta.Canvas.Handle, 0, 0, LARGURA_CARTA, ALTURA_CARTA,
          bmpCartasNormal.Canvas.Handle, (LongInt(FCartaAtual)*LARGURA_CARTA),
          (LongInt(FSuite)*ALTURA_CARTA), FModoPintura);
    end;
  end
  else
    BitBlt(bmpCarta.Canvas.Handle, 0, 0, LARGURA_CARTA, ALTURA_CARTA,
      bmpCartaVirada.Canvas.Handle, 0, 0, FModoPintura);

  BitBlt(Canvas.Handle, 0, 0, LARGURA_CARTA, ALTURA_CARTA,
    bmpCarta.Canvas.Handle, 0, 0, SRCCOPY);
end;

procedure TCarta.SetCarta(pValor: TBaralho);
begin
  CartaAtual := Integer(pValor);
end;

procedure TCarta.SetNaipe(pValor: TNaipe);
begin
  Suite := Integer(pValor);
end;

initialization

  if (not Assigned(bmpCartasNormal)) then
  begin
    bmpCartasNormal := TBitmap.Create;
    bmpCartasNormal.LoadFromResourceName(HInstance, 'CARTAS_NORMAL');
  end;

  if (not Assigned(bmpCartaVirada)) then
  begin
    bmpCartaVirada := TBitmap.Create;
    bmpCartaVirada.LoadFromResourceName(HInstance, 'CARTA_VIRADA');
  end;

  if (not Assigned(bmpCartaCuringa)) then
  begin
    bmpCartaCuringa := TBitmap.Create;
    bmpCartaCuringa.LoadFromResourceName(HInstance, 'CARTA_CURINGA');
  end;

finalization

  if (Assigned(bmpCartasNormal)) then
    FreeAndNil(bmpCartasNormal);

  if (Assigned(bmpCartaVirada)) then
    FreeAndNil(bmpCartaVirada);

  if (Assigned(bmpCartaCuringa)) then
    FreeAndNil(bmpCartaCuringa);

end.
