unit uAgenda;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Unit1, ImgList, IWImageList, Menus, IWHTMLControls, IWCompLabel,
  IWVCLBaseContainer, IWContainer, IWHTMLContainer, IWHTML40Container, IWRegion,
  IWVCLBaseControl, IWBaseControl, IWBaseHTMLControl, IWControl, IWCompMenu,
  IWCompEdit, IWCompButton, IWCompListbox, IWCompCheckbox, DB, IWGrids,
  IWDBGrids, IWAppForm, IWJQueryWidget, IWRenderContext, IWExtCtrls;

type
  TfrmAgenda = class(TfrmBase)
    IWRegion2: TIWRegion;
    edtDataIni: TIWEdit;
    edtDataFim: TIWEdit;
    IWLabel3: TIWLabel;
    IWLabel4: TIWLabel;
    IWLabel5: TIWLabel;
    IWLabel6: TIWLabel;
    cmbUsuarios: TIWComboBox;
    bPesquisar: TIWButton;
    dsAgenda: TDataSource;
    bCadastrar: TIWButton;
    cmbSituacao: TIWComboBox;
    IWDBGrid1: TIWDBGrid;
    IWJQueryWidget1: TIWJQueryWidget;
    iwImgAlterar: TIWImageFile;
    iwImgConcluir: TIWImageFile;
    iwImgExcluir: TIWImageFile;
    procedure IWAppFormCreate(Sender: TObject);
    procedure bCadastrarClick(Sender: TObject);
    procedure bPesquisarClick(Sender: TObject);
    procedure iwImgExcluirClick(Sender: TObject);
    procedure IWDBGrid1Columns0Click(ASender: TObject; const AValue: string);
    procedure iwImgAlterarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmAgenda: TfrmAgenda;

implementation

uses ServerController, uCadAgenda, UserSessionUnit;
{$R *.dfm}

procedure TfrmAgenda.IWAppFormCreate(Sender: TObject);
begin
  inherited;
  //ajusta as datas iniciais do filtro
  edtDataIni.Text := FormatDateTime('DD/MM/YYYY', Date);
  edtDataFim.Text := FormatDateTime('DD/MM/YYYY', Date + 30);

  //abre a tabela de usurios
  if not UserSession.cdsUsuarios.Active then
    UserSession.cdsUsuarios.Open;
  //ordena por nome
  UserSession.cdsUsuarios.IndexFieldNames := 'NOMUSU';
  UserSession.cdsUsuarios.First;
  //adiciona o primeiro item que representar "todos" os usurios
  cmbUsuarios.Items.Add('Todos=');
  //percorre a tabela adicionando aos items do IWComboBox os
  //usurios no formato Nome=Codigo
  while not UserSession.cdsUsuarios.eof do
  begin
    cmbUsuarios.Items.Add(UserSession.cdsUsuariosNOMUSU.Value + '=' +
        UserSession.cdsUsuariosCODUSU.AsAnsiString);
    UserSession.cdsUsuarios.Next;
  end;
  //fecha a tabela e remove a ordenao
  UserSession.cdsUsuarios.Close;
  UserSession.cdsUsuarios.IndexFieldNames := '';

  //seleciona todos os usurios e situaes para o filtro inicial
  cmbUsuarios.ItemIndex := 0;
  cmbSituacao.ItemIndex := 0;

  //Simula o clique no boto pesquisar para apresentar os dados
  bPesquisarClick(bPesquisar);
end;

procedure TfrmAgenda.IWDBGrid1Columns0Click(ASender: TObject;
  const AValue: string);
begin
  inherited;
  UserSession.cdsAgenda.Locate('CODAGE', AValue, []);
end;

procedure TfrmAgenda.iwImgAlterarClick(Sender: TObject);
begin
  inherited;
  //ajusta a varivel de controle de acordo com quem chamou a procedure
  if Sender = iwImgAlterar then
    UserSession.OperacaoAgenda := 'A'
  else
    UserSession.OperacaoAgenda := 'C';

  //coloca o registro em modo de edio
  UserSession.cdsAgenda.Edit;
  //Libera o form atual da memria
  TIWAppForm(WebApplication.ActiveForm).Release;
  //chama o form de Cadastro de Agendamentos
  TfrmCadAgenda.Create(WebApplication).Show;
end;

procedure TfrmAgenda.iwImgExcluirClick(Sender: TObject);
begin
  inherited;
  //elimina o registro da memria
  UserSession.cdsAgenda.Delete;
  //tenta mandar para o banco e se no der certo, mostra mensagem de erro
  if UserSession.cdsAgenda.ApplyUpdates(0) <> 0 then
    raise Exception.Create('No Foi Possvel Excluir o Compromisso!')
  else //se der tudo certo, avisa o usurio do sucesso da operao
    WebApplication.ShowMessage('Compromisso Excludo Com Sucesso!');
end;

procedure TfrmAgenda.bCadastrarClick(Sender: TObject);
begin
  inherited;
  //ajusta a varivel de controle
  UserSession.OperacaoAgenda := 'I';
  //verifica se a tabela est aberta para poder pedir uma nova linha
  if not UserSession.cdsAgenda.Active then
    UserSession.cdsAgenda.Open;
  //abre um novo registro no cdsAgenda
  UserSession.cdsAgenda.Append;
  //Libera o form atual da memria
  TIWAppForm(WebApplication.ActiveForm).Release;
  //chama o form de Cadastro de Agendamentos
  TfrmCadAgenda.Create(WebApplication).Show;
end;

procedure TfrmAgenda.bPesquisarClick(Sender: TObject);
const
  sqlAgenda = 'Select ' +
    'A.INIAGE, A.CODAGE, A.TIPAGE, T.NOMTIP, A.CODUSU, U.NOMUSU, ' +
    'A.FIMAGE, A.SITAGE, A.ASSAGE, A.CONAGE, A.INCAGE, A.ALTAGE ' +
    'From AGENDA A Inner Join TIPOS_AGENDA T On A.TIPAGE = T.CODTIP ' +
    'Inner Join USUARIOS U On A.CODUSU = U.CODUSU Where %s' +
    'A.INIAGE Between ''%s 00:00:00'' And ''%s 23:59:59'' Order By A.INIAGE';
var
  d1, d2: TDateTime;
  criterio: String;
begin
  inherited;

  // valida a Data Inicial
  try
    d1 := StrToDate(edtDataIni.Text);
  except
    on E: Exception do
    begin
      WebApplication.ShowMessage('Data Inicial Invlida!');
      exit;
    end;
  end;

  // valida a Data Final
  try
    d2 := StrToDate(edtDataFim.Text);
  except
    on E: Exception do
    begin
      WebApplication.ShowMessage('Data Final Invlida!');
      exit;
    end;
  end;

  // valida o perdo informado
  if d1 > d2 then
  begin
    WebApplication.ShowMessage(
      'A data Inicial no pode ser Maior que a data Final');
    exit;
  end;

  criterio := '';

  // monta o critrio caso haja um usurio selecionado
  if cmbUsuarios.ItemIndex > 0 then
    criterio := criterio + ' A.CODUSU = ' + cmbUsuarios.Items.ValueFromIndex
      [cmbUsuarios.ItemIndex] + ' AND ';

  //monta o critrio caso haja uma situao selecionada
  if cmbSituacao.ItemIndex > 0 then
    criterio := criterio + ' A.SITAGE = ''' + cmbSituacao.Text + ''' AND ';

  //executa o select no banco para apresentar na grade
  with UserSession do
  begin
    cdsAgenda.Close;
    qryAgenda.SQL.Text := Format(sqlAgenda, [criterio,
      FormatDateTime('MM/DD/YYYY', d1), FormatDateTime('MM/DD/YYYY', d2)]);
    cdsAgenda.Open;
    IWDBGrid1.Summary := IntToStr(cdsAgenda.RecordCount) + ' Registro(s) Encontrado(s).';
  end;
end;

end.
