unit uCadAgenda;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Unit1, ImgList, IWImageList, Menus, IWHTMLControls, IWCompLabel,
  IWVCLBaseContainer, IWContainer, IWHTMLContainer, IWHTML40Container, IWRegion,
  IWVCLBaseControl, IWBaseControl, IWBaseHTMLControl, IWControl, IWCompMenu,
  IWCompListbox, IWDBStdCtrls, DB, IWCompMemo, IWCompEdit, IWCompButton,
  IWAppForm;

type
  TfrmCadAgenda = class(TfrmBase)
    IWLabel3: TIWLabel;
    cmbUsuario: TIWDBComboBox;
    dsAgenda: TDataSource;
    cmbSituacao: TIWDBComboBox;
    IWLabel4: TIWLabel;
    IWLabel5: TIWLabel;
    IWLabel6: TIWLabel;
    edtDataIni: TIWDBEdit;
    edtDataFim: TIWDBEdit;
    IWLabel7: TIWLabel;
    cmbTipo: TIWDBComboBox;
    IWLabel8: TIWLabel;
    memAssunto: TIWDBMemo;
    bGravar: TIWButton;
    bCancelar: TIWButton;
    lblConclusao: TIWLabel;
    memConclusao: TIWDBMemo;
    procedure IWAppFormCreate(Sender: TObject);
    procedure bCancelarClick(Sender: TObject);
    procedure bGravarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmCadAgenda: TfrmCadAgenda;

implementation

uses ServerController, UserSessionUnit, uAgenda;

{$R *.dfm}

procedure TfrmCadAgenda.IWAppFormCreate(Sender: TObject);
begin
  inherited;
  //se for uma operao de Concluso
  if UserSession.OperacaoAgenda = 'C' then
  begin
    //desabilita os componentes, exceto o campo Motivo de Concluso
    cmbUsuario.Editable := False;
    cmbTipo.Editable := False;
    edtDataIni.Editable := False;
    edtDataFim.Editable := False;
    cmbSituacao.Editable := False;
    memAssunto.Editable := False;

    //reposiciona o campo de Concluso
    lblConclusao.Top := 341;
    lblConclusao.Left := 24;
    lblConclusao.Visible := True;
    memConclusao.Top := 360;
    memConclusao.Left := 24;
    memConclusao.Visible := True;

    //reposiciona os botes Gravar e Cancelar
    bGravar.Top := 488;
    bGravar.Left := 24;
    bCancelar.Top := 488;
    bCancelar.Left := 128;

    //ajusta o ttulo da Janela
    IWLabel1.Caption := 'Concluso de Compromisso - Agenda On-Line ';

    //seleciona o tipo Concludo, caso no esteja tentando concluir um
    //compromisso j concludo.
    if UserSession.cdsAgendaSITAGE.Value <> 'Concludo' then
      UserSession.cdsAgendaSITAGE.Value := 'Concludo'
    else
    begin
      memConclusao.Editable := False;
      bGravar.Visible := False;
      JavaScript.Add('alert("No  Possvel Concluir um Compromisso J Concludo!");');
    end;
  end
  else
  begin
    //sendo incluso ou alterao, elimina a opo "Concludo" do IWDBComboBox,
    //pois ele s passar a ser concludo atravs da opo "C", de "Concluir",
    //porm, se estivermos alterando um Agendamento j concludo, no podemos
    //elimar este item do IWComboBox
    if UserSession.cdsAgendaSITAGE.Value <> 'Concludo' then
      cmbSituacao.Items.Delete(cmbSituacao.Items.IndexOf('Concludo'));

    //testa se  incluso ou alterao, para ajustar o ttulo
    if UserSession.OperacaoAgenda = 'I' then
      IWLabel1.Caption := 'Incluso de Compromisso - Agenda On-Line '
    else if UserSession.OperacaoAgenda = 'A' then
      IWLabel1.Caption := 'Alterao de Compromisso - Agenda On-Line ';
  end;

  //assim como no onCreate do frmAgenda, carrega no respectivo IWDBComboBox
  //os usurios cadastrados
  if not UserSession.cdsUsuarios.Active then
    UserSession.cdsUsuarios.Open;
  UserSession.cdsUsuarios.IndexFieldNames := 'NOMUSU';
  UserSession.cdsUsuarios.First;
  while not UserSession.cdsUsuarios.eof do
  begin
    cmbUsuario.Items.Add(UserSession.cdsUsuariosNOMUSU.Value + '=' +
        UserSession.cdsUsuariosCODUSU.AsAnsiString);
    UserSession.cdsUsuarios.Next;
  end;
  UserSession.cdsUsuarios.Close;
  UserSession.cdsUsuarios.IndexFieldNames := '';

  //Carrega no respectivo IWDBComboBox os Tipos de Agendamentos cadastradosS
  if not UserSession.cdsTiposAgenda.Active then
    UserSession.cdsTiposAgenda.Open;
  UserSession.cdsTiposAgenda.IndexFieldNames := 'NOMTIP';
  UserSession.cdsTiposAgenda.First;
  while not UserSession.cdsTiposAgenda.eof do
  begin
    cmbTipo.Items.Add(UserSession.cdsTiposAgendaNOMTIP.Value + '=' +
        UserSession.cdsTiposAgendaCODTIP.AsAnsiString);
    UserSession.cdsTiposAgenda.Next;
  end;
  UserSession.cdsTiposAgenda.Close;
  UserSession.cdsTiposAgenda.IndexFieldNames := '';
end;

procedure TfrmCadAgenda.bGravarClick(Sender: TObject);
begin
  inherited;
  if UserSession.cdsAgenda.ApplyUpdates(0) <> 0 then
    raise Exception.Create('Erro ao gravar o compromisso no banco de dados')
  else
  begin
    TIWAppForm(WebApplication.ActiveForm).Release;
    TfrmAgenda.Create(WebApplication).Show;
  end;
end;

procedure TfrmCadAgenda.bCancelarClick(Sender: TObject);
begin
  inherited;
  UserSession.OperacaoAgenda := #0;
  UserSession.cdsAgenda.Cancel;
  TIWAppForm(WebApplication.ActiveForm).Release;
  TfrmAgenda.Create(WebApplication).Show;
end;

end.
