unit FIngrediente;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, DBCtrls, Grids, DBGrids, StdCtrls, uDBConfiguration;

type
  TfrmIngrediente = class(TForm)
    lblPreco: TLabel;
    lblUnidadeMedida: TLabel;
    lblIngrediente: TLabel;
    edtPreco: TEdit;
    edtUnidadeMedida: TEdit;
    edtIngrediente: TEdit;
    btnSalvarFechar: TButton;
    btnSalvarNovo: TButton;
    btnCancelar: TButton;
    procedure btnCancelarClick(Sender: TObject);
    procedure btnSalvarNovoClick(Sender: TObject);
    procedure btnSalvarFecharClick(Sender: TObject);
  private
    oIsAlter : Boolean;
    oID : Integer;
    procedure Save(aIsSaveAndNew : Boolean);
  public
    procedure ExecuteToAlter(aID: Integer; aIngrediente, aUnidade : string; aPreco : Double);
  end;

var
  frmIngrediente: TfrmIngrediente;

implementation

uses UDM;

{$R *.dfm}

procedure TfrmIngrediente.btnCancelarClick(Sender: TObject);
begin
  Self.Close;
end;

procedure TfrmIngrediente.btnSalvarFecharClick(Sender: TObject);
begin
  Self.Save(False);
end;

procedure TfrmIngrediente.btnSalvarNovoClick(Sender: TObject);
begin
  Self.Save(True);

  edtPreco.Clear;
  edtUnidadeMedida.Clear;
  edtIngrediente.Clear;
end;

procedure TfrmIngrediente.ExecuteToAlter(aID: Integer; aIngrediente, aUnidade: string; aPreco: Double);
begin
  oIsAlter := True;
  oID := aID;

  edtPreco.Text := FormatFloat('0.00', aPreco);
  edtUnidadeMedida.Text := aUnidade;
  edtIngrediente.Text := aIngrediente;

  Self.ShowModal;
end;

procedure TfrmIngrediente.Save(aIsSaveAndNew : Boolean);
begin

  if (not oIsAlter) then begin
    if not TDBConfig.GetInstance.SaveIngrediente(edtIngrediente.Text,
                                          edtUnidadeMedida.Text,
                                          StrToFloatDef(edtPreco.Text, 0)) then begin
      Exit;
    end;
  end
  else begin
    if not TDBConfig.GetInstance.AlterIngrediente(oID, edtIngrediente.Text,
                                          edtUnidadeMedida.Text,
                                          StrToFloatDef(edtPreco.Text, 0)) then begin
      Exit;
    end;
  end;


  if not aIsSaveAndNew then begin
    Self.Close;
  end
end;

end.
