unit FMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ToolWin, ComCtrls, ExtCtrls, jpeg, Menus,
  uDBConfiguration, uReceita;

type
  TfrmMain = class(TForm)
    stbMain: TStatusBar;
    mnuMain: TMainMenu;
    actArquivo: TMenuItem;
    actCadastroReceita: TMenuItem;
    actCadastrarIngrediente: TMenuItem;
    actCadastrarResponsavel: TMenuItem;
    N1: TMenuItem;
    actSair: TMenuItem;
    actSobre: TMenuItem;
    pnlMainLeft: TPanel;
    sptMain: TSplitter;
    pnlMainBody: TPanel;
    trvReceita: TTreeView;
    pnlLeftTop: TPanel;
    pnlReceitaTitulo: TPanel;
    edtReceita: TRichEdit;
    actOperacoes: TMenuItem;
    actIngrediente: TMenuItem;
    Responsveis1: TMenuItem;
    actAlterIngrediente: TMenuItem;
    actAltResponsavel: TMenuItem;
    ppmMain: TPopupMenu;
    actAlterarReceita: TMenuItem;
    actExcluirReceita: TMenuItem;
    procedure actSairClick(Sender: TObject);
    procedure actCadastroReceitaClick(Sender: TObject);
    procedure actCadastrarResponsavelClick(Sender: TObject);
    procedure actCadastrarIngredienteClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure actAlterIngredienteClick(Sender: TObject);
    procedure actAltResponsavelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure trvReceitaChange(Sender: TObject; Node: TTreeNode);
    procedure actAlterarReceitaClick(Sender: TObject);
    procedure actExcluirReceitaClick(Sender: TObject);
  private
    oReceita : TReceitaMain;

    procedure CarregaTree;
    function CheckIndex(aCategoria : string) : Integer;
    procedure ExpandTree;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses FIngrediente, FReceita, FResponsavel, FShowIngredientes, FShowResponsaveis;

{$R *.dfm}

procedure TfrmMain.actAlterarReceitaClick(Sender: TObject);
begin
  if (trvReceita.Selected.Level = 0) then begin
    MessageDlg('No  possvel alterar categorias.', mtInformation, [mbOK], 0);
  end
  else begin
    frmReceita := TfrmReceita.Create(nil);
    try
      frmReceita.Alterar(TReceita(oReceita.ListReceitas[oReceita.IndexOfReceitaByTit(trvReceita.Selected.Text)]));
    finally
      FreeAndNil(frmReceita);
      TDBConfig.GetInstance.CarregaReceitas(oReceita);
      Self.CarregaTree;
      Self.ExpandTree;
    end;
  end;
end;

procedure TfrmMain.actAlterIngredienteClick(Sender: TObject);
begin
  frmShowIngredientes := TfrmShowIngredientes.Create(nil);
  try
    frmShowIngredientes.Execute;
  finally
    frmShowIngredientes.Destroy;
  end;
end;

procedure TfrmMain.actAltResponsavelClick(Sender: TObject);
begin
  frmShowResponsaveis := TfrmShowResponsaveis.Create(nil);
  try
    frmShowResponsaveis.Execute;
  finally
    frmShowResponsaveis.Destroy;
  end;
end;

procedure TfrmMain.actCadastrarIngredienteClick(Sender: TObject);
begin
  frmIngrediente := TfrmIngrediente.Create(nil);
  try
    frmIngrediente.ShowModal;
  finally
    FreeAndNil(frmIngrediente);
  end;
end;

procedure TfrmMain.actCadastrarResponsavelClick(Sender: TObject);
begin
  frmResponsavel := TfrmResponsavel.Create(nil);
  try
    frmResponsavel.ShowModal;
  finally
    FreeAndNil(frmResponsavel);
  end;
end;

procedure TfrmMain.actCadastroReceitaClick(Sender: TObject);
begin
  frmReceita := TfrmReceita.Create(nil);
  try
    frmReceita.ShowModal;
  finally
    FreeAndNil(frmReceita);
    TDBConfig.GetInstance.CarregaReceitas(oReceita);
    Self.CarregaTree;
    Self.ExpandTree;
  end;
end;

procedure TfrmMain.actExcluirReceitaClick(Sender: TObject);
begin
  if (trvReceita.Selected.Level = 0) then begin
    MessageDlg('No  possvel excluir categorias.', mtInformation, [mbOK], 0);
  end
  else begin
    TDBConfig.GetInstance.DeleteReceita(oReceita.GetIDReceita(trvReceita.Selected.Text));
    TDBConfig.GetInstance.CarregaReceitas(oReceita);
    Self.CarregaTree;
    Self.ExpandTree;
  end;
end;

procedure TfrmMain.actSairClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TfrmMain.CarregaTree;
var
  I : Integer;
  vIndexPai : Integer;
begin
  trvReceita.Items.Clear;

  for I := 0 to oReceita.ListReceitas.Count - 1 do begin
    vIndexPai := Self.CheckIndex(TReceita(oReceita.ListReceitas[I]).Categoria);
    if (vIndexPai = -1) then begin
      trvReceita.Items.Insert(nil, TReceita(oReceita.ListReceitas[I]).Categoria);
      vIndexPai := Self.CheckIndex(TReceita(oReceita.ListReceitas[I]).Categoria);
      trvReceita.Items.AddChild(trvReceita.Items[vIndexPai], TReceita(oReceita.ListReceitas[I]).Titulo);
    end;              
  end;
end;

function TfrmMain.CheckIndex(aCategoria : string) : Integer;
var
  J : Integer;
begin
  Result := -1;
  for J := 0 to trvReceita.Items.Count - 1 do begin
      if (trvReceita.Items[J].Text = aCategoria) then begin
        Result := J;
        Break
      end;
  end;
end;

procedure TfrmMain.ExpandTree;
var
  I : Integer;
begin
  for I := 0 to trvReceita.Items.Count - 1 do begin
    trvReceita.Items[I].Expand(True);
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  oReceita := TReceitaMain.Create;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  oReceita.Destroy;
  TDBConfig.DestroyInstance;
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
  TDBConfig.GetInstance.CarregaReceitas(oReceita);
  Self.CarregaTree;
  Self.ExpandTree;
end;

procedure TfrmMain.trvReceitaChange(Sender: TObject; Node: TTreeNode);
begin
  edtReceita.Lines.Text := oReceita.ShowReceita(trvReceita.Selected.Text);
end;

end.
