unit FReceita;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, DBCtrls, Grids, DBGrids, StdCtrls, ComCtrls,
  FAddIngrediente, uDBConfiguration, uReceita;

type
  TfrmReceita = class(TForm)
    lblTitulo: TLabel;
    edtTitulo: TEdit;
    lblRendimento: TLabel;
    edtRendimento: TEdit;
    lblCategoria: TLabel;
    cmbCategoria: TComboBox;
    grbIngredientes: TGroupBox;
    Label1: TLabel;
    lblResponsavel: TLabel;
    btnAdd: TButton;
    btnRmv: TButton;
    cmbResponsavel: TComboBox;
    gpbPreparo: TGroupBox;
    mmoPreparo: TMemo;
    gpbOBS: TGroupBox;
    mmoOBS: TMemo;
    btnCancelar: TButton;
    btnSalvarFechar: TButton;
    btnSalvarNovo: TButton;
    lstView: TListView;
    procedure btnCancelarClick(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure btnRmvClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure edtRendimentoKeyPress(Sender: TObject; var Key: Char);
    procedure btnSalvarNovoClick(Sender: TObject);
    procedure btnSalvarFecharClick(Sender: TObject);
  private
    oIsAlter : Boolean;
    oID : Integer;
    oLstResponsavel, oLstIDResp : TStringList;
    procedure Save(aIsSaveAndNew : Boolean);
  public
    procedure Alterar(aReceita : TReceita);
  end;

var
  frmReceita: TfrmReceita;

implementation

uses UDM;

{$R *.dfm}

procedure TfrmReceita.Alterar(aReceita: TReceita);
var
  I : Integer;
  vLstItem : TListItem;
begin
  oIsAlter := True;
  oID := aReceita.ID;
  edtTitulo.Text := aReceita.Titulo;
  edtRendimento.Text := IntToStr(aReceita.Rendimeneto);
  cmbCategoria.ItemIndex := cmbCategoria.Items.IndexOf(aReceita.Categoria);
  cmbResponsavel.ItemIndex := cmbResponsavel.Items.IndexOf(aReceita.Responsavel);
  mmoPreparo.Lines.Text := aReceita.Preparo;
  mmoOBS.Lines.Text := aReceita.Obs;

  for I := 0 to aReceita.LstIngrediente.Count - 1 do begin
    vLstItem := lstView.Items.Add;
    vLstItem.Caption := FormatFloat('0.00', TIngrediente(aReceita.LstIngrediente[I]).Quantidade);
    vLstItem.SubItems.Add(TIngrediente(aReceita.LstIngrediente[I]).Unidade);
    vLstItem.SubItems.Add(TIngrediente(aReceita.LstIngrediente[I]).Descricao);
    vLstItem.SubItems.Add(IntToStr(TIngrediente(aReceita.LstIngrediente[I]).ID));
  end;

  Self.ShowModal;
end;

procedure TfrmReceita.btnAddClick(Sender: TObject);
var
  vIngrediente, vUnidade, vID : string;
  vQtde : Double;
  vLstItem : TListItem;
begin
  frmAddIngrediente := TfrmAddIngrediente.Create(nil);
  try
    frmAddIngrediente.Execute(vIngrediente, vUnidade, vQtde, vID);
    vLstItem := lstView.Items.Add;
    vLstItem.Caption := FormatFloat('0.00', vQtde);
    vLstItem.SubItems.Add(vUnidade);
    vLstItem.SubItems.Add(vIngrediente);
    vLstItem.SubItems.Add(vID);
  finally
    frmAddIngrediente.Free;
  end;
end;

procedure TfrmReceita.btnCancelarClick(Sender: TObject);
begin
  Self.Close;
end;

procedure TfrmReceita.btnRmvClick(Sender: TObject);
begin
  lstView.DeleteSelected;
end;

procedure TfrmReceita.btnSalvarFecharClick(Sender: TObject);
begin
  Self.Save(False);
end;

procedure TfrmReceita.btnSalvarNovoClick(Sender: TObject);
begin
  Self.Save(True);
end;

procedure TfrmReceita.edtRendimentoKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9', Chr(8)]) then begin
    Key := #0;
  end;
end;

procedure TfrmReceita.FormCreate(Sender: TObject);
begin
  oLstResponsavel := TStringList.Create;
  oLstIDResp := TStringList.Create;
  TDBConfig.GetInstance.SearchRespForCombo(oLstResponsavel, oLstIDResp);
  cmbResponsavel.Items.Text := oLstResponsavel.Text;
end;

procedure TfrmReceita.FormDestroy(Sender: TObject);
begin
  oLstResponsavel.Free;
  oLstIDResp.Free;
end;

procedure TfrmReceita.Save(aIsSaveAndNew: Boolean);
begin

  if oIsAlter then begin
    TDBConfig.GetInstance.UpdateReceita(lstView, edtTitulo.Text, edtRendimento.Text,
                                      oLstIDResp[cmbResponsavel.ItemIndex],
                                      cmbCategoria.Text, mmoPreparo.Lines.Text,
                                      mmoOBS.Lines.Text, oID);
  end
  else begin
    TDBConfig.GetInstance.SaveReceita(lstView, edtTitulo.Text, edtRendimento.Text,
                                      oLstIDResp[cmbResponsavel.ItemIndex],
                                      cmbCategoria.Text, mmoPreparo.Lines.Text,
                                      mmoOBS.Lines.Text);
  end;

  if not aIsSaveAndNew then begin
    Self.Close;
  end;
end;

end.
