unit FResponsavel;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, DBCtrls, Grids, DBGrids, StdCtrls, Mask, uDBConfiguration;

type
  TfrmResponsavel = class(TForm)
    lblNome: TLabel;
    edtNome: TEdit;
    lblTelefone: TLabel;
    edtTelefone: TMaskEdit;
    lblMail: TLabel;
    edtEmail: TEdit;
    gpbUsuario: TGroupBox;
    ckbUser: TCheckBox;
    gpbInfoUser: TGroupBox;
    lblLogin: TLabel;
    edtLogin: TEdit;
    lblSenha: TLabel;
    edtSenha: TEdit;
    btnSalvarNovo: TButton;
    btnSalvarFechar: TButton;
    btnCancelar: TButton;
    procedure btnCancelarClick(Sender: TObject);
    procedure ckbUserClick(Sender: TObject);
    procedure btnSalvarNovoClick(Sender: TObject);
    procedure btnSalvarFecharClick(Sender: TObject);
  private
    oIsAlter : Boolean;
    oID : Integer;
    procedure Save(aIsSaveAndNew : Boolean);
  public
    procedure ExecuteToAlter(aID : Integer; aNome, aTel, aEmail, aLogin, aSenha : string; aIsUser : Boolean);
  end;

var
  frmResponsavel: TfrmResponsavel;

implementation

uses UDM;

{$R *.dfm}

procedure TfrmResponsavel.btnCancelarClick(Sender: TObject);
begin
  Self.Close;
end;

procedure TfrmResponsavel.btnSalvarFecharClick(Sender: TObject);
begin
  Self.Save(False);
end;

procedure TfrmResponsavel.btnSalvarNovoClick(Sender: TObject);
begin
  Self.Save(True);

  edtNome.Clear;
  edtTelefone.Clear;
  edtEmail.Clear;
  edtLogin.Clear;
  edtSenha.Clear;
  ckbUser.Checked := False;
end;

procedure TfrmResponsavel.ckbUserClick(Sender: TObject);
begin
  if (ckbUser.Checked) then begin
    gpbInfoUser.Enabled := True;
    edtLogin.SetFocus;
  end
  else begin
    gpbInfoUser.Enabled := False;
  end;
end;

procedure TfrmResponsavel.ExecuteToAlter(aID : Integer; aNome, aTel, aEmail, aLogin, aSenha: string; aIsUser: Boolean);
begin
  oIsAlter := True;
  oID := aID;

  edtNome.Text := aNome;
  edtTelefone.Text := aTel;
  edtEmail.Text := aEmail;
  edtLogin.Text := aLogin;
  edtSenha.Text := aSenha;
  ckbUser.Checked := aIsUser;

  Self.ShowModal;
end;

procedure TfrmResponsavel.Save(aIsSaveAndNew: Boolean);
begin

  if oIsAlter then begin
    TDBConfig.GetInstance.AlterReponsavel(oID, edtNome.Text, edtSenha.Text,
                                          edtTelefone.Text, edtEmail.Text,
                                          edtLogin.Text, ckbUser.Checked);
  end
  else begin
    TDBConfig.GetInstance.SaveResponsavel(edtNome.Text, edtSenha.Text,
                                          edtTelefone.Text, edtEmail.Text,
                                          edtLogin.Text, ckbUser.Checked);
  end;

  if not (aIsSaveAndNew) then begin
    Self.Close;
  end;

end;

end.
