unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ACBrBase, ACBrECF, ACBrDevice, ACBrECFClass;

type
  TForm1 = class(TForm)
    ACBrECF1: TACBrECF;
    btnLeituraX: TButton;
    GroupBox8: TGroupBox;
    btnVersaoSB: TButton;
    btnDtSB: TButton;
    btnModeloECF: TButton;
    btnNumECF: TButton;
    btnCNPJ: TButton;
    btnInscEstadual: TButton;
    btnGravarSR: TButton;
    btnEstadoECF: TButton;
    btnValidaSerial: TButton;
    GroupBox5: TGroupBox;
    btnAbreCupom: TButton;
    BtnVendeItem: TButton;
    btnPagamento: TButton;
    btnFechar: TButton;
    btnCancelaCupom: TButton;
    procedure btnLeituraXClick(Sender: TObject);
    procedure btnVersaoSBClick(Sender: TObject);
    procedure btnModeloECFClick(Sender: TObject);
    procedure btnInscEstadualClick(Sender: TObject);
    procedure btnValidaSerialClick(Sender: TObject);
    procedure btnGravarSRClick(Sender: TObject);
    procedure btnNumECFClick(Sender: TObject);
    procedure btnDtSBClick(Sender: TObject);
    procedure btnCNPJClick(Sender: TObject);
    procedure btnEstadoECFClick(Sender: TObject);
    procedure btnAbreCupomClick(Sender: TObject);
    procedure BtnVendeItemClick(Sender: TObject);
    procedure btnPagamentoClick(Sender: TObject);
    procedure btnFecharClick(Sender: TObject);
    procedure btnCancelaCupomClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses IniFiles;

procedure TForm1.btnLeituraXClick(Sender: TObject);
begin
  ACBrECF1.LeituraX;
end;

procedure TForm1.btnValidaSerialClick(Sender: TObject);
VAR
  ArqIni : TIniFile;
  Serial : String;
  GT     : String;
  GTNum  : Double;
begin
  Try
    ArqIni := TIniFile.Create(ExtractFilePath(Application.Exename)+'serial.ini');
    Serial := ArqIni.ReadString('ECF','Serial','');
    GT     := ArqIni.ReadString('ECF','GT','');
  Finally
    ArqIni.Free;
  end;

  if not ACBrECF1.Ativo then
    ACBrECF1.Ativar;


  if ACBrECF1.NumSerie = Serial then
    ShowMessage('Numero de Serie OK')
  else
    ShowMessage('Numero de serie invalido');


  if FormatFloat('0.00',ACBrECF1.GrandeTotal) = GT then
    ShowMessage('GT OK')
  else
    ShowMessage('GT Invalido');
end;

procedure TForm1.BtnVendeItemClick(Sender: TObject);
begin
  Try
    ACBrECf1.VendeItem('001','Item 1','I',1,1.00,0,'UN');
  Except
    On E: Exception do
     begin
      ShowMessage(E.Message);
     end;
  end;
end;

procedure TForm1.btnVersaoSBClick(Sender: TObject);
begin
  ShowMessage(ACBrECF1.NumVersao);
end;

procedure TForm1.btnFecharClick(Sender: TObject);
begin
  ACBrECF1.FechaCupom('Mensagem do Cupom : Active Delphi');
end;

procedure TForm1.btnPagamentoClick(Sender: TObject);
var
  Pgto  : TACBrECFFormaPagamento;
  Pgto2 : TACBrECFFormaPagamento;
begin
  Pgto := ACBrECF1.AchaFPGDescricao('Dinheiro',False,False);
  Pgto2 := ACBrECF1.AchaFPGDescricao('Carto',False,True);
  ACBrECF1.SubtotalizaCupom();

  ACBrECF1.EfetuaPagamento(Pgto.Indice,0.5,'',False);
  ACBrECF1.EfetuaPagamento(Pgto2.Indice,0.5,'',False);

end;

procedure TForm1.btnNumECFClick(Sender: TObject);
begin
  ShowMessage(ACBrECF1.NumECF);
end;

procedure TForm1.btnAbreCupomClick(Sender: TObject);
begin
  ACBrECF1.AbreCupom('11111111111','Cliente Fulano','Rua da Alfandega');
end;

procedure TForm1.btnCancelaCupomClick(Sender: TObject);
begin
  ACBrECF1.CancelaCupom;
end;

procedure TForm1.btnCNPJClick(Sender: TObject);
begin
  ShowMessage(ACBrECF1.CNPJ);
end;

procedure TForm1.btnDtSBClick(Sender: TObject);
begin
   ShowMessage(DateToStr(ACBrECF1.DataHoraSB));
end;

procedure TForm1.btnEstadoECFClick(Sender: TObject);
var
  EstadoECF : TACBrECFEstado;
begin
  //TACBrECFEstado = (estNaoInicializada, { Porta Serial ainda nao foi aberta }
  //              estDesconhecido, {Porta aberta, mas estado ainda nao definido}
  //                estLivre, { Impressora Livre, sem nenhum cupom aberto,
  //                            pronta para nova venda, Reducao Z e Leitura X ok,
  //                            pode ou nao j ter ocorrido 1 venda no dia...}
  //                estVenda, { Cupom de Venda Aberto com ou sem venda do 1 Item}
  //                estPagamento, { Iniciado Fechamento de Cupom com Formas Pagto
  //                                pode ou nao ter efetuado o 1 pagto. Nao pode
  //                                mais vender itens, ou alterar Subtotal}
  //                estRelatorio, { Imprimindo Cupom Fiscal Vinculado ou
  //                                Relatorio Gerencial }
  //                estBloqueada, { Reduao Z j emitida, bloqueada at as 00:00 }
  //                estRequerZ, {Reducao Z dia anterior nao emitida. Emita agora }
  //                estRequerX,  {Esta impressora requer Leitura X todo inicio de
  //                             dia. Imprima uma Leitura X para poder vender}
  //                estNaoFiscal  { Comprovante Nao Fiscal Aberto
  EstadoECF := ACBrECF1.Estado;
    if EstadoECF = estLivre then
      ShowMessage('Livre')
    else
      begin
       if (EstadoECF = estVenda) OR
          (EstadoECF = estPagamento) OR
          (EstadoECF = estRelatorio) then
          begin
            ShowMessage('Documento Aberto, vou cancelar o cupom');
            ACBrECF1.CancelaCupom;
          end;
end;
end;

procedure TForm1.btnGravarSRClick(Sender: TObject);
var
  ArqIni : TIniFile;
begin
  Try
    ArqIni := TIniFile.Create(ExtractFilePath(Application.Exename)+'serial.ini');
    ArqIni.WriteString('ECF','Serial',ACBrECF1.NumSerie);
    ArqIni.WriteString('ECF','GT',FormatFloat('0.00',ACBRECF1.GrandeTotal));
  Finally
    ArqIni.Free;
  end;
end;

procedure TForm1.btnInscEstadualClick(Sender: TObject);
begin
  ShowMessage(ACBrECF1.IE);
end;

procedure TForm1.btnModeloECFClick(Sender: TObject);
begin
  ShowMessage(ACBrECF1.ModeloStr + #13+#10 + ACBrECF1.SubModeloECF);
end;

end.
